#!/usr/bin/perl
use bignum;
push @INC,qq(./scripts);
require qq(io.pm);

sub read_phy_reg
{
my $phy = 1;
my $reg = $_[0];
my $data;
 $data = ($phy<<11)|($reg<<6)|1;
 outl(0xbfe10000 + 0x10,$data);
 while(inl(0xbfe10000 + 0x10) &1){};
 $data = inl(0xbfe10000 + 0x14) & 0xffff;
}

sub write_phy_reg
{
my $phy = 1;
my $reg = $_[0];
my $data = $_[1];

 outl(0xbfe10000 + 0x14,$data);

 $data = ($phy<<11)|($reg<<6)| 2 | 1 | 0xc;
 outl(0xbfe10000 + 0x10,$data);
 while(inl(0xbfe10000 + 0x10) &1){};
}

sub read_all
{
for($i=0;$i<32;$i++)
{
print qq(\n) if(($i&0xf) == 0);
printf("%04x ",read_phy_reg($i));
}
print qq(\n);
my $stat = read_phy_reg(17);
print qq("Link up\n) if($stat & 0x200);

my %speed = ( 0=>"10M",1=>"100M",2=>"1000M",3=>"unknow speed" );
my $speed = $speed{$stat>>14};
my $duplex = (($stat>>13)&1)?"duplex full":"duplex half";
my $link = (($stat>>10)&1)?"link up":"no link";
my $autoneg = (($stat>>11)&1)?"resolved":"unresolved";
my $crossover = (($stat>>6)&1)?"corssover":"";

print qq($speed $duplex $link $autoneg $crossover\n);



}


#write_phy_reg(0,0);
if (@ARGV==0)
{
read_all;
}
else
{
	eval "@ARGV";
}

